import os
from github import Github
from github import Auth

def auth():
    access_token = os.getenv("GITHUB_ACCESS_TOKEN")
    auth = Auth.Token(access_token)
    g = Github(auth=auth)
    return g

class GithubSearcher():
    def __init__(self, query):
        self.g = auth()
        self.query = query
        self.result = None

    def search_repo(self):
        self.result = self.g.search_repositories(self.query)
    
    def search_users(self):
        self.result = self.g.search_users(self.query)

    def get_result(self):
        return self.result

def main():
    # search using search_repo endpoint example
    """
    query = "python"
    searcher = GithubSearcher(query)
    searcher.search_repo()
    result = searcher.get_result()
    for repo in result:
        print(repo.full_name)
    """

    # search using search_users endpoint example
    query = "bpmcdevitt"
    searcher = GithubSearcher(query)
    searcher.search_users()
    result = searcher.get_result()
    for user in result:
        print(user.login)
    

    
if __name__ == "__main__":
    main()